> For the complete documentation index, see [llms.txt](https://docs.apono.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apono.io/api-reference/discovering-identity-attribute-types.md).

# Discovering Identity Attribute Types

Identity attribute types define how Apono identifies and evaluates identities in access flows.\
These types represent built-in identities (like users or groups) or custom attributes integrated from context integrations.

The available types vary depending on your account configuration and connected identity sources.\
To view the exact list of supported types, run the discovery script below.

```python
import os
import requests

API_URL = "https://api.apono.io/api/admin/v1/attributes"

def get_auth_headers() -> dict:
    token = os.getenv("APONO_TOKEN")
    if not token:
        raise RuntimeError("Missing APONO_TOKEN environment variable")
    return {
        "Authorization": f"Bearer {token}",
        "Accept": "*/*"
    }

def fetch_unique_attribute_types() -> set:
    headers = get_auth_headers()
    attribute_types = set()
    next_page_token = None

    while True:
        params = {}
        if next_page_token:
            params["page_token"] = next_page_token
        response = requests.get(API_URL, headers=headers, params=params)
        response.raise_for_status()
        data = response.json()

        for attribute_item in data.get("items", []):
            attr_type = attribute_item.get("type")
            if attr_type:
                attribute_types.add(attr_type)

        next_page_token = data.get("pagination", {}).get("next_page_token")
        if not next_page_token:
            break

    return attribute_types

if __name__ == "__main__":
    print(sorted(fetch_unique_attribute_types()))
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apono.io/api-reference/discovering-identity-attribute-types.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
